Subject: Re: [alpine-devel] Proposal: testsuite support in APKBUILDs

From: William Pitcock <[email-masked]>
Date: Thu, 26 Jan 2017 19:28:32 -0600

Hello,

In some ways I am inclined to agree with Jakub, mostly because "make
check" is the main way of invoking a testsuite on autotools platforms.
It is perhaps not the most correct description of the phase, but it
does fit with "make check" usage in autotools, so people would be
familiar with it.

Lets move forward with check phase and !check in $features?

William

On Thu, Jan 26, 2017 at 8:34 AM, 7heo <[email-masked]> wrote:
> Hey,
>
> Since we're talking about vocabulary and semantics, I would rather avoid check, since it doesn't reflect what happens. A testsuite is a suite (set of, ordered, predictable) of tests (dynamic procedure to validate an element, that has to be executed). A check is merely an observation with assertion on an existing state. As an example, you can check the door is open, but you have to test if the lock works (you can't just check it in normal conditions and without a specialized apparatus).
>
> Long story short, I don't have any problem with making it shorter and simpler, but I would rather have something that matches what is actually does. :)
>
> Theo.
>
> On Thu Jan 26 14:08:29 2017 GMT+0100, Jakub Jirutka wrote:
>> Hi,
>>
>> currently we have the following phases: sanitycheck, builddeps, clean, fetch, unpack, prepare, mkusers, rootpkg, cleanup. All of them except rootpkg are verbs. So I’d prefer “check” (as Arch) instead of “testsuite”.
>>
>> Jakub
>>
>> > On 26. Jan 2017, at 10:26, Timo Teras <[email-masked]> wrote:
>> >
>> > On Wed, 25 Jan 2017 21:38:00 -0600
>> > William Pitcock <[email-masked]> wrote:
>> >
>> >> As such, I propose we add a testsuite() phase to the build process,
>> >> that runs after build(), but prior to package().  APKBUILDs should
>> >> override the testsuite phase, but the default_testsuite() function
>> >> will be a noop for the Alpine 3.6 release cycle that raises a warning
>> >> that the APKBUILD does not define any mechanism for running a
>> >> testsuite.  If "!testsuite" is defined in $features, the warning is
>> >> ignored.
>> >>
>> >> For cross-builds, the testsuite would be skipped unless the package
>> >> is noarch.
>> >>
>> >> After Alpine 3.6 (or maybe 3.7), we change the warning to a fatal
>> >> error, requiring APKBUILDs to explicitly opt out of running a
>> >> testsuite through $features.
>> >>
>> >> Thoughts?
>> >
>> > +1
>> >
>> > We have some packages that run 'make check' or similar, but it would be
>> > good to make it a separate step.
>> >
>> > The above plan sounds good to me.
>> >
>> > Thanks,
>> > Timo
>> >
>> >
>> > ---
>> > Unsubscribe:  [email-masked]
>> > Help:         [email-masked]
>> > ---
>> >
>>
>>
>>
>> ---
>> Unsubscribe:  [email-masked]
>> Help:         [email-masked]
>> ---
>>
>>

---
Unsubscribe:  [email-masked]
Help:         [email-masked]
---